﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.Threading

Imports FT_HANDLE = System.UInt32
Public Class Form1



    Inherits Form

    Public Const FT_OPEN_BY_SERIAL_NUMBER = &H1
    Public Const FT_OPEN_BY_DESCRIPTION = &H2

    ' FT_ListDevices Flags (used in conjunction with FT_OpenEx Flags)
    Public Const FT_LIST_NUMBER_ONLY = &H80000000
    Public Const FT_LIST_BY_INDEX = &H40000000
    Public Const FT_LIST_ALL = &H20000000

    Public Const FT_LIST_MASK = (FT_LIST_NUMBER_ONLY Or FT_LIST_BY_INDEX Or FT_LIST_ALL)

    ' Baud Rates
    Public Enum FT_BAUD As Integer
        FT_BAUD_300 = 300
        FT_BAUD_600 = 600
        FT_BAUD_1200 = 1200
        FT_BAUD_2400 = 2400
        FT_BAUD_4800 = 4800
        FT_BAUD_9600 = 9600
        FT_BAUD_14400 = 14400
        FT_BAUD_19200 = 19200
        FT_BAUD_38400 = 38400
        FT_BAUD_57600 = 57600
        FT_BAUD_115200 = 115200
        FT_BAUD_230400 = 230400
        FT_BAUD_460800 = 460800
        FT_BAUD_921600 = 921600
    End Enum

    ' Word Lengths
    Public Enum FT_BITS As Byte
        FT_BITS_8 = 8
        FT_BITS_7 = 7
        FT_BITS_6 = 6
        FT_BITS_5 = 5
    End Enum

    ' Stop Bits
    Public Enum FT_STOP As Byte
        FT_STOP_BITS_1 = 0
        FT_STOP_BITS_1_5 = 1
        FT_STOP_BITS_2 = 2
    End Enum

    ' Parity
    Public Enum FT_PARITY As Byte
        FT_PARITY_NONE = 0
        FT_PARITY_ODD = 1
        FT_PARITY_EVEN = 2
        FT_PARITY_MARK = 3
        FT_PARITY_SPACE = 4
    End Enum

    ' Flow Control
    Public Enum FT_FLOW As Short
        FT_FLOW_NONE = &H0
        FT_FLOW_RTS_CTS = &H100
        FT_FLOW_DTR_DSR = &H200
        FT_FLOW_XON_XOFF = &H400
    End Enum

    ' Purge rx and tx buffers
    Public Enum FT_PURGE_ As Byte
        FT_PURGE_RX = 1
        FT_PURGE_TX = 2
    End Enum

    ' Events
    Public Const FT_EVENT_RXCHAR = 1
    Public Const FT_EVENT_MODEM_STATUS = 2

    ' Device status
    Public Enum FT_STATUS As Integer
        FT_OK = 0
        FT_INVALID_HANDLE = 1
        FT_DEVICE_NOT_FOUND = 2
        FT_DEVICE_NOT_OPENED = 3
        FT_IO_ERROR = 4
        FT_INSUFFICIENT_RESOURCES = 5
        FT_INVALID_PARAMETER = 6
        FT_INVALID_BAUD_RATE = 7
        FT_DEVICE_NOT_OPENED_FOR_ERASE = 8
        FT_DEVICE_NOT_OPENED_FOR_WRITE = 9
        FT_FAILED_TO_WRITE_DEVICE = 10
        FT_EEPROM_READ_FAILED = 11
        FT_EEPROM_WRITE_FAILED = 12
        FT_EEPROM_ERASE_FAILED = 13
        FT_EEPROM_NOT_PRESENT = 14
        FT_EEPROM_NOT_PROGRAMMED = 15
        FT_INVALID_ARGS = 16
        FT_OTHER_ERROR = 17
    End Enum

    Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" Alias "FT_ListDevices" (ByRef pArg1 As Int32, ByVal pArg2 As Int32, ByVal Flags As Int32) As FT_STATUS
    Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" Alias "FT_ListDevices" (ByVal pArg1 As Int32, ByVal pArg2() As Byte, ByVal Flags As Int32) As FT_STATUS
    Public Declare Function FT_Open Lib "FTD2XX.DLL" (ByVal deviceNumber As Integer, ByRef pHandle As Integer) As FT_STATUS
    Public Declare Function FT_OpenEx Lib "FTD2XX.DLL" (ByVal pArg1() As Byte, ByVal Flags As Integer, ByRef pHandle As Integer) As FT_STATUS
    Public Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal pHandle As Integer) As FT_STATUS
    ' Remember CE is UNICODE and not ASCII Characters! for read and write string
    Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal lpBuffer As String, ByVal nBufferSize As Integer, ByRef lpBytesReturned As Integer) As FT_STATUS
    Public Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal lpBuffer As String, ByVal nBufferSize As Integer, ByRef lpBytesWritten As Integer) As FT_STATUS
    Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal lpBuffer() As Byte, ByVal nBufferSize As Integer, ByRef lpBytesReturned As Integer) As FT_STATUS
    Public Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal lpBuffer() As Byte, ByVal nBufferSize As Integer, ByRef lpBytesWritten As Integer) As FT_STATUS
    Public Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal BaudRate As Integer) As FT_STATUS
    Public Declare Function FT_SetDataCharacteristics Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal WordLength As FT_BITS, ByVal StopBits As FT_STOP, ByVal Parity As FT_PARITY) As FT_STATUS
    Public Declare Function FT_SetFlowControl Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal FlowControl As FT_FLOW, ByVal XonChar As Byte, ByVal XoffChar As Byte) As FT_STATUS
    Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS
    Public Declare Function FT_SetDtr Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS
    Public Declare Function FT_ClrDtr Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS
    Public Declare Function FT_SetRts Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS
    Public Declare Function FT_ClrRts Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS
    Public Declare Function FT_GetModemStatus Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByRef pModemStatus As Long) As FT_STATUS
    Public Declare Function FT_SetChars Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal EventChar As Byte, ByVal EventCharEnabled As Byte, ByVal ErrorChar As Byte, ByVal ErrorCharEnabled As Byte) As FT_STATUS
    Public Declare Function FT_Purge Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal Mask As Integer) As FT_STATUS
    Public Declare Function FT_SetTimeouts Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal ReadTimeout As Integer, ByVal WriteTimeout As Integer) As FT_STATUS
    Public Declare Function FT_GetQueueStatus Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByRef dwRxBytes As Integer) As FT_STATUS
    Public Declare Function FT_SetEventNotification Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByVal Mask As Integer, ByVal Param As Long) As FT_STATUS
    Public Declare Function FT_GetEventStatus Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByRef dwEventsDWord As Integer) As FT_STATUS
    Public Declare Function FT_GetStatus Lib "FTD2XX.DLL" (ByVal ftHandle As Integer, ByRef dwRxBytes As Integer, ByRef dwTxBytes As Integer, ByRef dwEventDWord As Integer) As FT_STATUS
    Public Declare Function FT_SetBreakOn Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS
    Public Declare Function FT_SetBreakOff Lib "FTD2XX.DLL" (ByVal ftHandle As Integer) As FT_STATUS

    ' For event notification you will need to use the following kernel functions
    '   Public Declare Function CreateEvent Lib "Coredll.dll" (ByVal lpEventAttributes As Integer, ByVal bManualReset As Byte, ByVal bInitialState As Byte, ByVal lpName As String) As Integer
    '   Public Declare Function WaitForSingleObject Lib "Coredll.dll" (ByVal hHandle As Integer, ByVal dwMilliseconds As Integer) As Integer
    '   Public Declare Function SetEvent Lib "Coredll.dll" (ByVal hHandle As Integer) As Integer
    '   Public Declare Function CloseHandle Lib "Coredll.dll" (ByVal hHandle As Integer) As Integer


    Protected dwListDescFlags As UInt32
    Public Shared m_hPort As UInt32
    Protected fContinue As Boolean

    Public portA As Byte
    Public portB As Byte
    Public portC As Byte

    Public Sub New()
        InitializeComponent()
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_hPort = 0
        fContinue = False
        dwListDescFlags = FT_LIST_ALL
        ' radNumber.Checked = true;
        radSerial.Checked = True
        btnClose.Enabled = False
        btnOpen.Enabled = True
        btnTest.Enabled = False
        radDescription.Enabled = True
        radSerial.Enabled = True
        radNumber.Enabled = True
        cmbDevList.Enabled = True

        btnPAPUOn.Enabled = False
        btnPAPUOff.Enabled = False

        If ListUnopenDevices() = False Then
            MessageBox.Show("Error Listing Devices")
        End If

        cmbDevList.SelectedIndex = 0
    End Sub


    Private Function ListUnopenDevices() As Boolean
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR
        Dim numDevs As Integer = 0
        Dim i As Integer
        Dim sDevName As Byte() = New Byte(63) {}
        Dim iCurrentIndex As Integer


        iCurrentIndex = cmbDevList.SelectedIndex()
        cmbDevList.Items.Clear()


        ftStatus = FT_ListDevices(numDevs, 0, FT_LIST_NUMBER_ONLY)

        If ftStatus = FT_STATUS.FT_OK Then
            If dwListDescFlags = FT_LIST_ALL Then
                For i = 0 To numDevs - 1
                    cmbDevList.Items.Add(i)
                Next
            Else
                For i = 0 To numDevs - 1

                    ftStatus = FT_ListDevices(i, sDevName, dwListDescFlags)
                    If ftStatus = FT_STATUS.FT_OK Then
                        Dim str As String
                        Dim enc As New System.Text.ASCIIEncoding()
                        str = enc.GetString(sDevName, 0, sDevName.Length)
                        cmbDevList.Items.Add(str)
                    Else
                        MessageBox.Show("Error list devices" & Convert.ToString(ftStatus), "Error")
                        Return False
                    End If

                Next
            End If
        End If
        cmbDevList.SelectedIndex = iCurrentIndex
        Return True
    End Function

    Private Sub radDescription_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles radDescription.CheckedChanged
        dwListDescFlags = FT_LIST_BY_INDEX Or FT_OPEN_BY_DESCRIPTION
        If ListUnopenDevices() = False Then
            MessageBox.Show("Error Listing Devices")
        End If
    End Sub

    Private Sub radSerial_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles radSerial.CheckedChanged
        dwListDescFlags = FT_LIST_BY_INDEX Or FT_OPEN_BY_SERIAL_NUMBER
        If ListUnopenDevices() = False Then
            MessageBox.Show("Error Listing Devices")
        End If
    End Sub

    Private Sub radNumber_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles radNumber.CheckedChanged
        dwListDescFlags = FT_LIST_ALL
        If ListUnopenDevices() = False Then
            MessageBox.Show("Error Listing Devices")
        End If
    End Sub


    Private Sub btnRefresh_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnRefresh.Click
        ListUnopenDevices()
    End Sub


    Private Sub btnOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOpen.Click
        Dim dwOpenFlag As UInt32
        Dim uiCurrentIndex As UInteger
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR

        If m_hPort = 0 Then
            dwOpenFlag = dwListDescFlags And Not FT_LIST_BY_INDEX
            dwOpenFlag = dwListDescFlags And Not FT_LIST_ALL

            If dwOpenFlag = 0 Then
                uiCurrentIndex = CUInt(cmbDevList.SelectedIndex)
                ftStatus = FT_Open(uiCurrentIndex, m_hPort)
            Else
                Dim enc As New System.Text.ASCIIEncoding()
                Dim sDevName As Byte() = enc.GetBytes(cmbDevList.Text)
                ftStatus = FT_OpenEx(sDevName, dwOpenFlag, m_hPort)

            End If
        End If

        If ftStatus = FT_STATUS.FT_OK Then
            ' Set up the port
            FT_SetBaudRate(m_hPort, 9600)
            FT_Purge(m_hPort, FT_PURGE_.FT_PURGE_RX Or FT_PURGE_.FT_PURGE_TX)
            FT_SetTimeouts(m_hPort, 3000, 3000)
            ' Start up the read and write thread
            fContinue = True
            'pThreadRead = new Thread(new ThreadStart(ReadThread));
            'pThreadRead.Start();
            ' Enable buttons that can be pressed
            btnClose.Enabled = True
            btnOpen.Enabled = False
            btnTest.Enabled = True

            btnPAPUOn.Enabled = True
            btnPAPUOff.Enabled = True

            radDescription.Enabled = False
            radSerial.Enabled = False
            radNumber.Enabled = False
            cmbDevList.Enabled = False
            label2.Text = "Connection Successful"
        Else
            MessageBox.Show("Failed To Open Port" & Convert.ToString(ftStatus))
        End If
    End Sub


    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        If m_hPort <> 0 Then
            fContinue = False
            ' it will stop in 3 seconds - not sure if this is proper
            'Thread.Sleep(3000);
            FT_Close(m_hPort)


            m_hPort = 0
        End If
        ' radNumber.Checked = true;
        btnClose.Enabled = False
        btnOpen.Enabled = True
        btnTest.Enabled = False

        btnPAPUOn.Enabled = False
        btnPAPUOff.Enabled = False

        radDescription.Enabled = True
        radSerial.Enabled = True
        radNumber.Enabled = True
        cmbDevList.Enabled = True
        label2.Text = "Disconnected"
    End Sub




    Private Sub btnTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnTest.Click
        Dim bFail As Boolean = False

        WritePullup("A", &HFF)
        WritePullup("B", &HFF)
        WritePullup("C", &HFF)

        ' Port A Test
        WriteDirection("A", &H0)
        WriteDirection("B", &HFF)
        WriteDirection("C", &HFF)

        TestTextBox.Clear()
        Application.DoEvents()


        WriteValue("A", &H55)
        PollPorts()
        TestTextBox.AppendText("----------" & vbCr & vbLf)
        TestTextBox.AppendText("IO: 0x00:0xFF:0xFF" & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        TestTextBox.AppendText("A :55:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :55:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :55:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portB <> &H55 OrElse portC <> &H55 Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("A", &HAA)
        PollPorts()
        TestTextBox.AppendText("A :AA:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :AA:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :AA:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portB <> &HAA OrElse portC <> &HAA Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("A", &H0)
        PollPorts()
        TestTextBox.AppendText("A :00:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :00:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :00:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portB <> &H0 OrElse portC <> &H0 Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("A", &HFF)
        PollPorts()
        TestTextBox.AppendText("A :FF:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :FF:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :FF:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portB <> &HFF OrElse portC <> &HFF Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If


        If bFail Then
            Exit Sub
        End If

        TestTextBox.Clear()
        Application.DoEvents()


        ' Port B Test
        WriteDirection("A", &HFF)
        WriteDirection("B", &H0)
        WriteDirection("C", &HFF)

        WriteValue("B", &H55)
        PollPorts()
        TestTextBox.AppendText("----------" & vbCr & vbLf)
        TestTextBox.AppendText("IO: 0xFF:0x00:0xFF" & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        TestTextBox.AppendText("A :55:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :55:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :55:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &H55 OrElse portC <> &H55 Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("B", &HAA)
        PollPorts()
        TestTextBox.AppendText("A :AA:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :AA:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :AA:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &HAA OrElse portC <> &HAA Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("B", &H0)
        PollPorts()
        TestTextBox.AppendText("A :00:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :00:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :00:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &H0 OrElse portC <> &H0 Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("B", &HFF)
        PollPorts()
        TestTextBox.AppendText("A :FF:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :FF:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :FF:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &HFF OrElse portC <> &HFF Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If


        If bFail Then
            Exit Sub
        End If

        TestTextBox.Clear()
        Application.DoEvents()


        ' Port C Test
        WriteDirection("A", &HFF)
        WriteDirection("B", &HFF)
        WriteDirection("C", &H0)

        WriteValue("C", &H55)
        PollPorts()
        TestTextBox.AppendText("----------" & vbCr & vbLf)
        TestTextBox.AppendText("IO: 0xFF:0xFF:0x00" & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        TestTextBox.AppendText("A :55:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :55:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :55:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &H55 OrElse portB <> &H55 Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("C", &HAA)
        PollPorts()
        TestTextBox.AppendText("A :AA:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :AA:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :AA:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &HAA OrElse portB <> &HAA Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("C", &H0)
        PollPorts()
        TestTextBox.AppendText("A :00:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :00:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :00:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &H0 OrElse portB <> &H0 Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If

        WriteValue("C", &HFF)
        PollPorts()
        TestTextBox.AppendText("A :FF:" & portA.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("B :FF:" & portB.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("C :FF:" & portC.ToString("X") & vbCr & vbLf)
        TestTextBox.AppendText("" & vbCr & vbLf)
        If portA <> &HFF OrElse portB <> &HFF Then
            TestTextBox.AppendText("Fail!!" & vbCr & vbLf)
            bFail = True
        End If


        If bFail Then
            Exit Sub

        End If
        TestTextBox.AppendText("Loop Back Test Passed!" & vbCr & vbLf)
    End Sub

    Private Sub PollPorts()
        portA = ReadValue("a")
        portB = ReadValue("b")
        portC = ReadValue("c")
    End Sub

    Private Sub WriteValue(ByVal port As Char, ByVal value As Byte)
        Dim dwRet As UInt32 = 0
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR
        Dim cBuf As Byte() = New Byte(4) {}

        cBuf(0) = AscW(port)
        cBuf(1) = value

        ftStatus = FT_Write(m_hPort, cBuf, 2, dwRet)

    End Sub

    Private Sub WriteDirection(ByVal port As Char, ByVal value As Byte)
        Dim dwRet As UInt32 = 0
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR
        Dim cBuf As Byte() = New Byte(4) {}

        cBuf(0) = AscW("!")
        cBuf(1) = AscW(port)
        cBuf(2) = value

        ftStatus = FT_Write(m_hPort, cBuf, 3, dwRet)

    End Sub

    Private Sub WritePullup(ByVal port As Char, ByVal value As Byte)
        Dim dwRet As UInt32 = 0
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR
        Dim cBuf As Byte() = New Byte(4) {}

        cBuf(0) = AscW("#")
        cBuf(1) = AscW(port)
        cBuf(2) = value

        ftStatus = FT_Write(m_hPort, cBuf, 3, dwRet)

    End Sub

    Private Function ReadValue(ByVal port As Char) As Byte
        Dim dwRet As UInt32 = 0
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR
        Dim cBuf As Byte() = New Byte(4) {}

        cBuf(0) = AscW(port)


        ftStatus = FT_Write(m_hPort, cBuf, 1, dwRet)

        If ftStatus <> FT_STATUS.FT_OK Then
            MessageBox.Show("Failed To Write " & Convert.ToString(ftStatus))
        End If

        dwRet = 0
        Dim timeout As Long
        timeout = 0

        Dim rxCount As UInt32

        If rbPro.Checked Then
            rxCount = 2
        Else
            rxCount = 1
        End If
        Do
            ftStatus = FT_GetQueueStatus(m_hPort, dwRet)
            timeout += 1
        Loop While (dwRet <> rxCount) AndAlso (timeout < 100000)

        If Timeout = 100000 Then
            'MessageBox.Show("Timeout while reading " + Convert.ToString(ftStatus));
            Return 0
        End If




        ftStatus = FT_Read(m_hPort, cBuf, rxCount, dwRet)


        If ftStatus <> FT_STATUS.FT_OK Then
            MessageBox.Show("Failed To Read " & Convert.ToString(ftStatus))
        End If

        If rbPro.Checked Then
            Return (cBuf(1))
        Else
            Return (cBuf(0))
        End If
    End Function

    Private Sub TestTextBox_DoubleClick(ByVal sender As Object, ByVal e As EventArgs) Handles TestTextBox.DoubleClick
        TestTextBox.Clear()
    End Sub

    Private Sub btnSPILoopback_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSPILoopback.Click
        Dim dwRet As UInt32 = 0
        Dim ftStatus As FT_STATUS = FT_STATUS.FT_OTHER_ERROR
        Dim btTs As Byte() = New Byte(9) {}

        Dim tsSyncByte As Byte = &H47

        Dim timeout As Long

        WriteDirection("A"c, &H4)

        TestTextBox.Clear()
        TestTextBox.AppendText("Test Start" & vbCr & vbLf)


        For i As Integer = 0 To 9999
            ' CS high
            btTs(0) = AscW("A")
            btTs(1) = &H8

            ' SYNC high
            btTs(2) = AscW("H")
            btTs(3) = &H6

            ' TS SYNC byte
            btTs(4) = AscW("S")
            btTs(5) = tsSyncByte

            ' SYNC low
            btTs(6) = AscW("L")
            btTs(7) = &H6

            ' CS low
            btTs(8) = AscW("A")
            btTs(9) = &H0


            ftStatus = FT_Write(m_hPort, btTs, 10, dwRet)


            timeout = 0
            Do
                ftStatus = FT_GetQueueStatus(m_hPort, dwRet)
                timeout += 1
            Loop While (dwRet <> 2) AndAlso (timeout < 100000)

            If timeout = 100000 Then
                'MessageBox.Show("Timeout while reading " + Convert.ToString(ftStatus));
                TestTextBox.AppendText("Timeout" & vbCr & vbLf)
                'return 0;
                Application.DoEvents()
            End If


            ftStatus = FT_Read(m_hPort, btTs, 2, dwRet)


            If ftStatus <> FT_STATUS.FT_OK Then
                MessageBox.Show("Failed To Read " & Convert.ToString(ftStatus))
            End If

            If btTs(1) <> tsSyncByte Then
                TestTextBox.AppendText(("Error: Wrote " & tsSyncByte.ToString("X") & ": Read ") + btTs(1).ToString("X") & vbCr & vbLf)
                Application.DoEvents()
            End If
        Next

        TestTextBox.AppendText("Test Finish" & vbCr & vbLf)
    End Sub

    Private Sub btnPAPUOn_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPAPUOn.Click
        WriteDirection("A", &HFF)
        WritePullup("A", &H0)
    End Sub

    Private Sub btnPAPUOff_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPAPUOff.Click
        WriteDirection("A", &HFF)
        WritePullup("A", &HFF)
    End Sub



   
  


End Class
